/* R-U-ON Mac Widget             */
/* Copyright (c) 2006-2008 R-U-ON LLC */
/* www.r-u-on.com                */

//todo: aid on download

// Consts
var ruonServer = "http://rss.r-u-on.com/";
var url = { "alarms":ruonServer+"rssalarms?mac&id=",
            "agents":ruonServer+"rssagents?mac&id=",
            "tickets":ruonServer+"rsstickets?mac&id=",
            "guid": "https://www.r-u-on.com/resolveGUID?"
};
var renderFields = {
    "agents": [ ["Agent", -1], ["Type", 120], ["IP",100], ["State", 40] ],
    "alarms": [ ["Agent", 100], ["Resource", 100], ["Description", -1] ],
    "tickets": [ ["TRK#",40], ["Title", 200], ["Opened By",-1] ]
};
var alarmParseFields = [ null, "Description", "Time Up" ];
var modeTitle = {"agents":"Agents", "alarms":"Alarms", "tickets":"Track Tickets"};
var modeAction = {"agents":"overview", "alarms":"alarms","tickets":"trk"};


// name, show field name, nowrap
var detailFields = {
    "alarms":[
            ["Agent", false, false], ["Resource", true, true],
            ["Time Up", false, true],null,["Description", false, false],null
            ],
    "agents":[
            ["Agent", true, true],["Type", true, true],["State", true, true],
            ["Severity", true, true],["IP", true, true],["Public IP", true, true],
            ["OS", true, true],["Group", true, true],["Last contact", true, true],
            ["Uptime", true, true]
            ],
    "tickets":[
                ["TRK#", true, true], ["Title", false, false],null, ["Opened By", true, true],
                ["Opened At", true, true], ["Status", true, true], ["Severity", true, true],
                ["Assigned To", true, true], ["Category", true, true]
            ]
};

var detailAliases = {"Last contact":"Hit", "Opened By":"By", "Opened At":"At", "Assigned To":"To"};

// State stuff
var state = "";
var details = false;
var xml_request = null;
var visible = true;
var selectedTr = null;
var refreshTimer = null;
var growlCommand = null;
var prevSnapshot = null;

// Various screen Elements
var animate = new Animate();
var scrollArea, scrollbar;

// Authenticaiton stuff
var authing=false;
var authTimer = null;
var authId = 0;
var authText = ["Logging in...", "Logging in", "Logging in.", "Logging in.."]

// Var Preferences
var user = "";
var passwordlen = 0;
var mode = "alarms";
var group = false;
var bgheight = 248;
var accountid = null;

// "Debugger"
var dbg = new NoDebug();

function getPref(key, def) {
    var v = window.widget.preferenceForKey(key);
    return v==null?def:v;
}
function getPrefInst(key, def) {
    return getPref(widget.identifier+"."+key, def);
}
function setPref(key, value) {
    window.widget.setPreferenceForKey(value, key);
}
function setPrefInst(key, value) {
    setPref(widget.identifier+"."+key, value);
}
function loadPreferences() {
    if (window.widget) {
        user = getPref("user", user);
        passwordlen = getPref("passwordlen", passwordlen);
        accountid = getPref("accountid", accountid);

        mode = getPrefInst("mode", mode);
        group = getPrefInst("group", group?"true":"false")=="true";
        bgheight = getPrefInst("bgheight", bgheight);
    }
}
function savePreferences() {
    if (window.widget) {
        setPref("user", user);
        setPref("passwordlen", passwordlen);
        setPref("accountid", accountid);

        setPrefInst("mode", mode);
        setPrefInst("group", group?"true":"false");
        setPrefInst("bgheight", bgheight);
    }
}

// Init
function load () {
    loadPreferences();
    scrollbar = new AppleVerticalScrollbar(document.getElementById("myScrollBar"));
	scrollArea = new AppleScrollArea(document.getElementById("contents"), scrollbar);
    scrollArea.scrollsHorizontally = false;
	scrollArea.singlepressScrollPixels = 3;

	scrollArea.focus(); // for key control when first loading in Safari

	window.onfocus = function () { scrollArea.focus(); }
	window.onblur = function () { scrollArea.blur(); }

    hhh = document.getElementById("background").offsetHeight;
    if (hhh!=bgheight) {
        resize(bgheight-hhh);
    }
    show ();
}
function show () {
    if (accountid==null) {
        showPrefs();
    } else {
        fetchInfo();
    }
}

if (window.widget) {
    widget.onshow = dashboardOn;
    widget.onhide = dashboardOff;
}

function dashboardOn() {
    if (!visible) {
        visible = true;
        if (refreshTimer==null) {
            show();
        }
    }
}
function dashboardOff() {
    //visible = false; , I want it to alawys work for Growl's sake...
}

// State Management
function setState(s) {
    state = s;
    dbg.print("Set state: "+s);
    document.getElementById("status").innerText = s;
}
function done(s) {
    dbg.print("Done: "+s)
    state = "";
    document.getElementById("status").innerText = s;
}
function isBusy(s) {
    if (state!="")
        dbg.print("Busy:"+s);
    return state!="";
}

// Fetch Data
function fetchInfo() {
    if (isBusy("fetch")||!visible) {
        refreshTimer = null;
        return;
    }
    document.getElementById("title").innerText = modeTitle[mode];
    setState("Loading...");
    if (xml_request != null)
    {
        xml_request.abort();
        xml_request = null;
    }

    try {
      xml_request = new XMLHttpRequest();

      xml_request.onreadystatechange = function(e) {xmlResult(e, xml_request, mode);}
      xml_request.overrideMimeType("text/xml");
      xml_request.open("GET", buildUrl());
      xml_request.setRequestHeader("Cache-Control", "no-cache");
      xml_request.send(null);
   } catch (e) {
      alert(e);
   }
}
function buildUrl() {
    return url[mode] + accountid + (group?"&group":"");
}
function xmlResult(e, req, m) {
    var info;
    if (req.readyState == 4) {
        if (req.status == 200) {
            info = parseFeed(m, req.responseXML);
        } else {
            setNextRefresh(60*1000*10); // Try again in 10 minutes
            if (req.status==500) {
                info = exceptionInfo("Service Unavailable", "The R-U-ON Service is temporarily unavailable.")
            } else {
                if (req.status) {
                    info = exceptionInfo("Service unavailable", "HTTP Status code "+req.status);
                } else {
                    info = exceptionInfo("Service/Network unavailable", "Can't connect to server");
                }
            }
        }
    } else {
	// not interested in interim stages
	// but had to listen to all or i won't get errors
	return;
    }
    //alertInfo(info);
    try {
        render(info);
        done("Updated "+nowString());
    } catch(e) {
        done(e.message);
    }

}
function exceptionInfo(title, description) {
    var result = new Object();

    result.type = "exception";
    result.title = title;
    result.description = description;
    return result;
}
function alertInfo(info) {
    if (info.type=="exception") {
        alert(info.title+"\r\n"+info.description);
    } else if (info.type=="alarms" || info.type=="agents" || info.type=="tickets") {
        var s = "";
        for (var i=0;i<info.rows.length;++i) {
            s+=array2string(info.rows[i])+"\r\n";
        }
        alert(info.type+": "+info.rows.length + "\r\n"+s)
    } else {
        alert("Unknown info type: "+info.type)
    }
}
function parseFeed(m, doc) {
    try {
        var items = doc.getElementsByTagName("item");
        var ttl = doc.getElementsByTagName("ttl").item(0).firstChild.nodeValue;
        setNextRefresh(ttl*60*1000);

        var result = new Object();

        // Is Exception
        if (items.length==1) {
            var title = items[0].getElementsByTagName("title").item(0).firstChild.nodeValue;
            if (title=="R-U-ON Feed Exception") {
                result = exceptionInfo(title, items[0].getElementsByTagName("description").item(0).childNodes.item(1).nodeValue);
                return result;
            }
        }

        if (m=="alarms") {
            result.type = "alarms";
            result.rows = [];
            for (var i=0;i<items.length;++i) {
                result.rows[i] = parseAlarm(items[i]);
            }
	        analyzeDelta(result);
        } else if (m==="agents") {
            result.type = "agents";
            result.rows = [];
            for (var i=0;i<items.length;++i) {
                result.rows[i] = parseAgent(items[i]);
            }
    	    analyzeDelta(result);
        } else if (m=="tickets") {
            result.type = "tickets";
            result.rows = [];
            for (var i=0;i<items.length;++i) {
                result.rows[i] = parseTicket(items[i]);
            }
            if (group) {
                ticketsGroupSort(result.rows);
            }
            analyzeDelta(result);
        } else {
            result = exceptionInfo("Unknown mode", "mode=\""+m+"\"");
        }
    } catch(e) {
        result = exceptionInfo("Parsing Error", e.message);
    }
    return result;
}
function ticketsGroupSort(rows) {
    var origPos = [];
    for (var i=0;i<rows.length;++i) {
        origPos[rows[i]["TRK#"]] = i;
    }
    rows.sort(function(a,b){
        if (a["Group"]==b["Group"]) {
            return (origPos[a["TRK#"]] > origPos[b["TRK#"]])?1:-1;
        } else {
            if (a["Group"]=="None") {
                return -1;
            }
            if (b["Group"]=="None") {
                return 1;
            }
            return a["Group"]>b["Group"]?1:-1;
        }
    });
}
function parseAlarm(node) {
    var alarm = new Array();
    var title = node.getElementsByTagName("title").item(0).firstChild.nodeValue;
    var cdata = node.getElementsByTagName("description").item(0).childNodes.item(1).nodeValue;

    var ix = title.lastIndexOf(": ");
    alarm['Agent'] = title.substr(0, ix);
    alarm['Severity'] = title.substr(ix+2, title.length-ix-2);

    var cp = cdata.split("<br>");
    for (var i=0;i<cp.length;++i) {
        if (alarmParseFields[i]==null) {
            var s = cp[i];
            var idx = s.indexOf(": ");
            var k = s.substr(0, idx);
            var v = s.substr(idx+2, s.length - idx - 2);
            alarm[k] = v;
        } else {
            alarm[alarmParseFields[i]] = cp[i];
        }
    }

    alarm['link'] = node.getElementsByTagName("link").item(0).firstChild.nodeValue;
    alarm['guid'] = node.getElementsByTagName("guid").item(0).firstChild.nodeValue;
    alarm['severity'] = alarm["Severity"]

    return alarm;
}
function parseAgent(node) {
    var agent = [];
    var title = node.getElementsByTagName("title").item(0).firstChild.nodeValue;
    var cdata = node.getElementsByTagName("description").item(0).childNodes.item(1).nodeValue;

    agent['Agent'] = title;

    var cp = cdata.split("<br>");
    for (var i=0;i<cp.length;++i) {
        var s = cp[i];
        var idx = s.indexOf(": ");
        var k = s.substr(0, idx);
        var v = s.substr(idx+2, s.length - idx - 2);
        agent[k] = v;
    }
    agent['link'] = node.getElementsByTagName("link").item(0).firstChild.nodeValue;
    agent['guid'] = node.getElementsByTagName("guid").item(0).firstChild.nodeValue;
    agent['text'] = cdata;
    agent['severity'] = agent['Severity'];
    return agent;
}
function parseTicket(node) {
    var ticket = [];
    var title = node.getElementsByTagName("title").item(0).firstChild.nodeValue;
    var cdata = node.getElementsByTagName("description").item(0).childNodes.item(1).nodeValue;

    var ix = title.indexOf(": ");
    ticket['TRK#'] = title.substr(1, ix-1);
    ticket['Title'] = title.substr(ix+2, title.length-ix-2);


    var cp = cdata.split("<br>");
    for (var i=0;i<cp.length;++i) {
        var s = cp[i];
        var idx = s.indexOf(": ");
        var k = s.substr(0, idx);
        var v = s.substr(idx+2, s.length - idx - 2);
        ticket[k] = v;
    }
    ticket['link'] = node.getElementsByTagName("link").item(0).firstChild.nodeValue;
    ticket['guid'] = node.getElementsByTagName("guid").item(0).firstChild.nodeValue;
    ticket['text'] = cdata;
    ticket["Group"] = ticket["Category"];
    if (ticket["Group"]==null) {
        ticket["Group"] = "None";
    }

    if (ticket["Status"]=="Closed") {
        ticket["severity"] = "Okay";
    } else if (ticket["Status"]=="Resolved") {
        ticket["severity"] = "Resolved";
    } else {
        ticket["severity"] = ticket["Severity"];
    }
    return ticket;
}
function array2string(a) {
    var s = "";
    for (k in a) {
        s+=k+":"+a[k]+"|";
    }
    return s;
}
function setNextRefresh(milisec) {
    if (refreshTimer!=null) {
        clearTimeout(refreshTimer);
    }
    refreshTimer = setTimeout("fetchInfo()", milisec);
}

// Render Data
function render(result) {

    var contents = document.getElementById("content");
    var thetable = document.getElementById("thetable");
    while (thetable.hasChildNodes()) {
        thetable.removeChild(thetable.firstChild);
    }

    if (result.type=="exception") {
        document.getElementById("error.title").innerText = result.title;
        document.getElementById("error.description").innerText = result.description;
        document.getElementById("nofeed").style.display = "block";
        return;
    }

    document.getElementById("nofeed").style.display = "none";
    document.getElementById("noagents").style.display = "none";
    document.getElementById("noalarms").style.display = "none";
    document.getElementById("notickets").style.display = "none";

    var fields;
    if (result.rows.length==0) {
        document.getElementById("no"+mode).style.display = "block";
        return;
    }

    fields = renderFields[result.type];
    var agroup = "None";
    for (row in result.rows) {
        if (group && agroup!=result.rows[row]["Group"]) {
            agroup=result.rows[row]["Group"];
            thetable.appendChild(createRow( { "Agent":agroup, "Title":agroup, "severity":"GroupRow","noselect":true} ,fields));
        }
        var row = createRow(result.rows[row], fields);
        thetable.appendChild(row);
    }

    // update the scrollbar so scrollbar matches new data
    scrollArea.refresh();
}
function calculateReminder(fields) {
    var tableWidth = document.getElementById("thetable").offsetWidth;
    var total = 0;
    for (var i=0;i<fields.length;++i) {
        total += fields[i][1]<=0?0:fields[i][1];
    }
    return tableWidth - total;
}
function createRow (record, fields) {
	var row = document.createElement ("tr");

    for (var f in fields) {
        var field = fields[f];

        var td = document.createElement("td");
        var text = record[field[0]];
	text = text?text:"";
	var crx = text.indexOf("\n");
	if (crx>0) {
		text = text.substring(0, crx);
	}
        td.innerText = text;

        if (field[1]==-1) {
            field[1] = calculateReminder(fields);
        }
        td.setAttribute("width", field[1]+"px");

        td.setAttribute("class", "row notselected "+record["severity"]);
        td.therecord = record;
        td.setAttribute ("onclick", "clickOnRow(event, this);");
        if (f==fields.length-1) {
            td.setAttribute("style", "padding-right:8px");
        }
        row.appendChild (td);
    }
    return row;
}
function nowString() {
    var theDate = new Date();
    var theHour = String(theDate.getHours());
    var theMinutes = String(theDate.getMinutes());
    if (theMinutes.length == 1)
        theMinutes = "0" + String(theMinutes);
    if ( theHour > 12 ) {
        theHour = String(theHour - 12);
        amPM = "PM";
    } else {
        amPM = "AM";
    }

    if ( theHour == 12 ) amPM = "PM";
    if ( theHour == 0 ) theHour = "12";

    return theHour + ":" + theMinutes + amPM;
}

// Control
function selectRow(tr) {
    if (tr==selectedTr) {
        return false;
    }
    if (selectedTr!=null) {
        for (var i=0;i<selectedTr.childNodes.length;++i) {
            var cn = selectedTr.childNodes[i].className;
            selectedTr.childNodes[i].className = cn.replace("selected", "notselected");
        }
    }

    for (var i=0;i<tr.childNodes.length;++i) {
        var cn = tr.childNodes[i].className;
        tr.childNodes[i].className = cn.replace("notselected", "selected");
    }
    selectedTr = tr;
    return true;
}
function clickOnRow (event, td) {
    var record = td.therecord;
    if (!record["noselect"]) {
        if (selectRow(td.parentNode) || !details) {
        	showDetails(record);
	} else {
		hideDetails();
	}
    }
}
function openUrl(url) {
    if (window.widget) {
        widget.openURL (url);
	} else {
        document.location = url;
    }
}
function mainClick() {
    openUrl("http://www.r-u-on.com/ctrl?action="+modeAction[mode]);
}

// Animation
function Animate() {
    this.running = false;
    this.onend = "";
    this.conclude = function() {
        clearTimeout(this.timer);
        this.cursor = this.motion.length - 1;
        this.anim();
    }

    this.start = function(f, t, s, obj, attr, unit) {
        if (this.running) {
            this.conclude(obj);
        }
        this.obj = obj;
        this.unit = unit;
        this.motion = this.fillAnimate(f, t, s);
        this.cursor = 0;
        this.attr = attr;
        this.running = true;
        this.anim();

    }

    this.anim = function() {
        this.obj.style[this.attr] = this.motion[this.cursor]+this.unit;
        if ( (++this.cursor)>=this.motion.length) {
            this.running = false;
            if (this.onend!="") {
                eval(this.onend);
                this.onend = "";
            }
        } else {
            this.timer = setTimeout("animate.anim()", 13);
        }
    }
    this.setOnEnd = function(f) {
        this.onend += (";"+f);
    }

    this.fillAnimate = function(f, t, steps) {
        var step = (t - f) / steps;
        var a = [];
        for (var i=0;i<steps-1;++i) {
            a[i] =  f+(i+1)*step;
            if (this.unit=="px") {
                a[i] = Math.round(a[i]);
            }
        }
        a[steps-1] = t;
        return a;
    }

}

// Details
function detailHtml(record, meta) {
    var html="";
    for (var i=0;i<meta.length;++i) {
        if (meta[i]==null) {
            html+="<br>";
            continue;
        }
        var value = record[meta[i][0]];
        if (value==null) {
            continue;
        }
        if (meta[i][2]) { // nowrap
            html+='<span style="white-space: nowrap;">';
        }

        if (meta[i][1]) {
            var alias = detailAliases[meta[i][0]];
            html+='<span class="detailshead">'+(alias!=null?alias:meta[i][0])+": </span>";
        }

	value = value.replace(/\n/g, "<br>");

        html+=value;
        if (meta[i][2]) { // nowrap
            html+="</span>";
        }
        html+="<br>";
    }
    html+="<a href=\"javascript:openUrl('"+record["link"]+"')\">More...</a>";
    return html;
}
function showDetails(record) {
    if (!details) {
        toggleDetails();
    }
    var pane = document.getElementById("detailstext");
    pane.innerHTML = detailHtml(record, detailFields[mode]);

}
function hideDetails() {
    if (details) {
        toggleDetails();
    }
}
function toggleDetails() {

    var pane = document.getElementById("details");
    var main = document.getElementById("background");

    if (!details) {
        window.resizeBy(pane.offsetWidth, 0);
        var bg = document.getElementById("closerollie");
        bg.style.opacity = 0.1;
        openBorder(true);
    }

    var extendX = main.offsetWidth+main.offsetLeft;
    var shrinkX = extendX - pane.offsetWidth;

    var f = details?extendX:shrinkX;
    var t = details?shrinkX:extendX;

    animate.start(f, t, 5, pane, "left", "px");
    if (details) {
        animate.setOnEnd("openBorder(false);setTimeout('window.resizeBy(-"+pane.offsetWidth+",0);"+"',10);");
    }
    details = !details;
}
function enterCloseDetails(event) {
    var bg = document.getElementById("closerollie");
    animate.start(0.1, 0.25, 15, bg, "opacity", "");
    event.stopPropagation();
    event.preventDefault();
}
function exitCloseDetails(event) {
    var bg = document.getElementById("closerollie");
    animate.start(0.25, 0.1, 15, bg, "opacity", "");
    event.stopPropagation();
    event.preventDefault();
}
function openBorder(b) {
    var descOpen1 = document.getElementById("descOpen1");
    var descOpen2 = document.getElementById("descOpen2");
    var descOpen3 = document.getElementById("descOpen3");

    descOpen1.className = b?"t_ibl":"t_r";
    descOpen2.className = b?"t_c":"t_r";
    descOpen3.className = b?"t_itl":"t_r";
}

// Flippin'
var bruteForceTimer=null;
function mousemove(event) {
    if (bruteForceTimer!=null) {
        clearTimeout(bruteForceTimer);
    }
    bruteForceTimer=setTimeout('fadeOutI()', 5000);
    var flip = document.getElementById("flip");
    if (!flip.showin) {
        flip.showin = true;
        animate.start(0, 0.4, 15, flip, "opacity", "");
    }
}
function fadeOutI() {
    var flip = document.getElementById("flip");
    flip.showin = false;
    animate.start(0.4, 0, 15, flip, "opacity", "");
}
function enterflip(event) {
    document.getElementById('fliprollie').style.display = 'block';
    event.stopPropagation();
    event.preventDefault();

}
function exitflip(event) {
    document.getElementById('fliprollie').style.display = 'none';
    event.stopPropagation();
    event.preventDefault();
}
function showPrefs() {
    populatePrefs();
    if (isBusy("prefs")) {
        return;
    }
    setState("Preferences");
    if (details) {
        hideDetails();
        animate.setOnEnd("setTimeout('showPrefs2()',10)");
    } else {
        showPrefs2();
    }
}
function showPrefs2() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");          // freezes the widget so that you can change it without the user noticing
    }

    front.style.display="none";             // hide the front
    back.style.display="block";             // show the back

    if (window.widget) {
        setTimeout ('widget.performTransition();', 0);          // and flip the widget over
    }

    document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button
}
function doneDown(event) {
    document.getElementById("doneButton").src = "Images/done_pressed.png"
    event.stopPropagation();
    event.preventDefault();
}
function doneUp(event) {
    document.getElementById("doneButton").src = "Images/done.png";
    event.stopPropagation();
    event.preventDefault();
}
function doneClick(event) {
    preferenceDone();
}
function flipBack() {

    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");          // freezes the widget so that you can change it without the user noticing
    }

    back.style.display="none";             // hide the front
    front.style.display="block";             // show the back

    done("Preference Updated");
    if (window.widget) {
        setTimeout ('widget.performTransition();', 0);          // and flip the widget over
    }
    fetchInfo();
}
function textKey(event) {
    if (event.keyCode && event.keyCode == 13) {
        preferenceDone();
    }
}
function selectValue(select, value) {
    for (var i=0;i<select.length;++i) {
        if (select[i].value == value) {
            select.selectedIndex = i;
            return;
        }
    }
}
function dummyPassword() {
    var p="";
    while (p.length<passwordlen) {
        p+="|";
    }
    return p;
}
function populatePrefs() {
    selectValue(document.getElementById("mode"), mode);
    document.getElementById("emailinput").value = user;
    document.getElementById("passwordinput").value = dummyPassword();
    document.getElementById("openaccount").style.display = accountid==null?"block":"none";
    document.getElementById("group").checked = group;
}
function preferenceDone() {
    if (authing) {
        return;
    }
    // regular stuff
    var m  = document.getElementById("mode");
    mode = m[m.selectedIndex].value;
    group = document.getElementById("group").checked;

    // user password
    var nUser = document.getElementById("emailinput").value;
    var nPassword = document.getElementById("passwordinput").value;

    if (accountid==null || nUser!=user || nPassword!=dummyPassword()) {
        authenticate(nUser, nPassword);
    } else {
        savePreferences();
        flipBack();
    }
}

// Authenticate
function authenticate(u, p) {
    authing = true;
    animAuth();

    var req = new XMLHttpRequest();
    req.onreadystatechange = accountId;
    req.open("GET", url["guid"]+'email='+encodeURIComponent(u)+"&password="+encodeURIComponent(p), true);
    req.send();
    function accountId() {
        if (req.readyState == 4) {
            if (req.status == 200) {
                try {
                    parseGUID(req.responseXML, u, p);
                } catch (e) {
                    stopAnimAuth("Internal Error: "+e.message);
                }
            } else {
                stopAnimAuth("Can't connect to server");
            }
        }
    }

}
function parseGUID(doc, u, p) {
    var list = doc.getElementsByTagName("error");
    if (list.length>0) {
        stopAnimAuth(list.item(0).firstChild.nodeValue);
    } else {
        list = doc.getElementsByTagName("guid");
        if (list.length>0) {
            accountid = list.item(0).firstChild.nodeValue;

            user = u;
            passwordlen = p.length;

            stopAnimAuth("");
            savePreferences();
            flipBack();
        } else {
            stopAnimAuth("Unknow result. Please try again later.")
        }
    }
}
function stopAnimAuth(msg) {
    authing = false;
    clearTimeout(authTimer);
    var a = document.getElementById("authenticating");
    a.innerText = msg;
}
function animAuth() {
    var a = document.getElementById("authenticating");
    a.innerText = authText[authId%authText.length];
    authId++;
    authTimer = setTimeout("animAuth()",250);
}


// Window Resize
var resize_last_y;
var resize_top=["noworry", "resize", "flip", "fliprollie", "cornercrop_bl", "cornercrop_br"];
var resize_height=["contents", "background", "myScrollBar", "details", "detailscontainer"];
var resize_fix = {"contents":-2};
var resize_ignore = 0;

function resize_mouse_down_handler (event, img) {
    document.addEventListener("mousemove", resize_mouse_move_handler, true);
    document.addEventListener("mouseup", resize_mouse_up_handler, true);

    //scrollbar.hide();

    resize_last_y = event.y;

    event.stopPropagation();
    event.preventDefault();
}
function resize_mouse_move_handler (event) {

    var deltay = event.y - resize_last_y;
    resize_last_y = event.y;

    resize(deltay);
    event.stopPropagation();
    event.preventDefault();
}
function resize(deltay) {

    var current = document.getElementById("background").offsetHeight;
    if (resize_ignore<0) {
        resize_ignore +=deltay;
        if (resize_ignore>0) {
            deltay = resize_ignore;
            resize_ignore = 0;
        } else {
            return;
        }
    }

    if (current+deltay<248) {
        var realdeltay =  248-current;
        resize_ignore = deltay - realdeltay;
        deltay = realdeltay;
    }

    scrollbar.hide();
    document.getElementById("fliprollie").style.display = "block";
    // height objects
    for (var i=0;i<resize_height.length;++i) {
        var o = document.getElementById(resize_height[i]);
        var fix = resize_fix[resize_height[i]];
        if(!fix){
            fix = 0;
        }
        o.style.height = o.offsetHeight+deltay+fix;
    }

    // top objects
    for (var i=0;i<resize_top.length;++i) {
        var o = document.getElementById(resize_top[i]);
        o.style.top = o.offsetTop+deltay+"px";
    }
    document.getElementById("fliprollie").style.display = "none";

    if (deltay>0) {
        scrollbar.scrollByThumbDelta(-deltay);
    }

    scrollbar.refresh();
    scrollArea.refresh();
    scrollbar.setAutohide(true);

    if (window.widget) {
        window.resizeBy(0, deltay);
    }
}
function resize_mouse_up_handler (event){
        document.removeEventListener("mousemove", resize_mouse_move_handler, true);
        document.removeEventListener("mouseup", resize_mouse_up_handler, true);

        resize_ignore = 0;
        if (window.widget) {
            bgheight = document.getElementById("background").offsetHeight;
            savePreferences();
        }

        event.stopPropagation();
        event.preventDefault();
}

// Delta for notification
function analyzeDelta(snapshot) {
	snapshot.guidmap = [];
	for (row in snapshot.rows) {
        row = snapshot.rows[row];
        snapshot.guidmap[row["guid"]] = row;
	}
	if (prevSnapshot!=null) {
		if (prevSnapshot.type==snapshot.type) {
            for (row in snapshot.rows) {
                row = snapshot.rows[row];
                var otherrow = prevSnapshot.guidmap[row["guid"]];
                if (otherrow==null) {
                    deltaNewRow(snapshot.type, row);
                } else {
                    delete prevSnapshot.guidmap[row["guid"]];
                    if (otherrow["severity"]!=row["severity"]) {
                        deltaSevChange(snapshot.type, otherrow, row);
                    }
                }

            }
            for (oldrow in prevSnapshot.guidmap) {
                oldrow = prevSnapshot.guidmap[oldrow];
                deltaClearedRow(snapshot.type, oldrow);
            }
        }
	}
	prevSnapshot = snapshot;
}
function deltaNewRow(type, row) {
    if (row["severity"]!="Okay") {
        notifyRaise(type, row);
    }
}
function deltaSevChange(type, oldrow, newrow) {
    if (newrow["severity"]=="Okay") {
        notifyClear(type, newrow);
    } else {
        notifyRaise(type, newrow);
    }
}
function deltaClearedRow(type,oldrow) {
    if (oldrow["severity"]!="Okay") {
        notifyClear(type, oldrow);
    }
}

// Notify
function notifyRaise(type, row) {
    if (type=="agents") {
        notifyAgent(row, true);
    } else if (type=="tickets") {
        notifyTicket(row, true);
    } else {
        notifyAlarm(row, true);
    }
}
function notifyClear(type, row) {
    if (type=="agents") {
        if (row["severity"]=="Okay") // Otherwise we are getting the old row which means uninstall not clear
            notifyAgent(row, false);
    } else if (type="tickets") {
        if (row["severity"]=="Okay") // if it has dissapeared than we are not sure closed then forget it
            notifyAgent(row, false);
    } else {
        notifyAlarm(row, false);
    }
}
function notifyAgent(row, up) {
    var sev = up?row["severity"]:"Clear";
    var title = row["Agent"]+" "+(up?row["severity"]:"Okay");
    var description="";
    var fields = ["Type", "State", "IP"];
    for (field in fields) {
        field = fields[field];
        description+=(field+": "+row[field]+"\n");
    }
    //growl(sev, title, description);
}
function notifyTicket(row, up) {
    if (!up) {
        return;
    }
    if (row["Status"]!="Open") {
        return;
    }
    var sev = up?row["severity"]:"Clear";
    var title = "TRK# "+row["TRK#"]+" "+row["Severity"];
    var description=row["Title"]+"\n"+"By "+row["Opened By"];
    if (row["Category"]!=null) {
        description+=("\n"+row["Category"]);
    }
    //growl(sev, title, description);
}
function notifyAlarm(row, up) {
    var sev = up?row["severity"]:"Clear";
    var title = row["Agent"]+": ";
    if (up) {
        title+=row["severity"]+" Alarm";
    } else {
        title+="Alarm Clear";
    }
    var description="Resource: "+row["Resource"]+"\n"+row["Description"];
    //growl(sev, title, description);
}

// Growl
function pathify(s) {
	s = s.replace("\\\\", "\\\\");
	s = s.replace("\"", "\\\"");
	return "\""+s+"\"";
}
function growlComplete(ret) {
}
function growl(severity, title, description) {
	var sevmap = {"Critical":1, "Major":2, "Minor":3, "Okay":4, "Clear":4};

	title = pathify(title);
	description = pathify(description);
	severity = sevmap[severity];

	var gscpt = pathify("`pwd`/growl.scpt");
	var img = pathify("`pwd`/Images/logo.png");
	var osa = "/usr/bin/osascript";

	var cmdline = osa+" "+gscpt+" "+severity+" "+title+" "+
		      description+" "+img;
	if (window.widget) {
		growlCommand = widget.system(cmdline, growlComplete);
	} else {
		alert(cmdline);
	}
}

// Debug
function NoDebug() {
    this.print = function(s) {
    }
    this.printObject = function(s,o) {
    }
}
function Debug() {
    this.even = false;
    this.print = function(s) {
	log(s);
    }
    this.printHTML = function(s) {
        var bg = this.even?"background-color:lightgreen;":"";
        this.even = !this.even;
        this.debugWin.document.writeln('<div style="width:100%;'+bg+'font-family:arial;font-size:8pt">'+s+'<br></div>');
        this.debugWin.scrollBy(0,1000);
    }
    this.printObject = function(s,o) {
        if (o==null) {
            this.print(s+":null");
            return;
        }
        for (a in o) {
            try {
                s+= "\n"+a+": "+o[a];
            } catch (e) {
                s+= "\n"+a+": "+e.message;
            }
        }
        this.print(s);
    }

    //this.debugWin = window.open("", "__dbg", "height=300,width=300,top=0,left=0");
    //var doc = this.debugWin.document;
    //this.print("<br><br><br><br><br><br><br><br>");
    //this.print("Debug Started!")
    //this.debugWin.document.open();
}
var logcmd=null;
function log(s) {
	if (window.widget) {
		if (logcmd==null)
			logcmd  = widget.system("/bin/cat >> /tmp/widget.log", function(s){});
		logcmd.write(s);
		//cmd.close();
	}
}
function dump(o,level) {
	if (!level) level = 0;
	if (typeof(o)=="object") {
		for (a in o) {
			for (var i=0;i<level;i++) log("   ");
			log(a);
			log(":");
			try {
				dump(o[a], level+1);
			} catch(e) {
				log ("exception");
			}
			log("\n");
		}
	} else {
		log(o+"\n");
	}
}



